/**************************************************************************/
/*                                                                        */
/* nom du fichier: depouil.c                                              */
/*                                                                        */
/* Utilitaire permettant de depouiller les transferts de donnees          */
/* de dumont d'urville                                                    */
/* Verivier que les fichiers .bat sont bien a jour                        */
/* genere des fichiers .log d'execution de la procedure                   */
/*                                                                        */
/* by P.GENAU                                                             */
/*                                                                        */
/**************************************************************************/

#include<stdio.h>
#include<string.h>
#include <time.h>
#include <ftw.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdlib.h>
#include <sys/types.h>

#include "constantes.h"
#include "typedef.h"


STFICHE *debut,*fin,*fiche;
STTYPE *debut_type,*debut_inv;
STCAL *debut_cal,*fiche_cal;

char rep_base[255];
        /* repertoire de travail de base */
char rep_prog[255];
char rep_data[255];

extern int recup_fich();
extern void trait_lidar();
extern int trait_sond_meteo();
extern void trait_bonjour();
extern void trait_saoz();
extern void trait_lidar_temp();

main(argc,argv)
int argc;
char *argv[];
{
STSAISIEPARAM saisie; /* structure contenant les infos utilisateur */

FILE *fopen(),*fp_type,*fp_trans,*fp_log,*fp_dir,*fp_tlas,*fp_antar,*fp_antartype;
FILE *fp_insert,*fp_attente,*fp_ohp;
char num_trans[4],date_trans[40];
char nom_trans[40],commande[100];
char nomfich[255],newnom[50],logname[255];
char type[20],manip[20],*buf,*buf2,ligne[100],ligne2[100],heure[5],date[7],*ptr;
char jour[3],mois[3],an[5],*ctime(),date_depouil[35];
char jour_trans[3],mois_trans[3],an_trans[5];
int i,j,status,year,jday,ret_ftw;
char c_jday[4];
char sujet[100];
char destinataires[100];
booleen bool,bool_fin,bool_err,trouve;
struct tm *tmptr,tmvar;
int retour;
time_t nseconds;
STTYPE *fin_type,*fiche_type;
STTYPE *fin_inv,*fiche_inv;
STCAL *fin_cal,*fiche_cal;

/* recuperation d'un eventuel repertoire de base pour */
/* le traitement */
/* ------------------------------------- */
if(getenv("TRAIT_DDU") != NULL)
	strcpy(rep_base,getenv("TRAIT_DDU"));
else
	strcpy(rep_base,"/ndsc/prog/adelie");

/* saisie des parametres */
/* --------------------- */
saisie_param(&saisie,argc,argv);

if(saisie.repdata[0] != 0)
	strcpy(rep_data,saisie.repdata);
else
	sprintf(rep_data,"%s/new",rep_base);
		
if(saisie.repprog[0] != 0)
	sprintf(rep_prog,"%s",saisie.repprog);
else
	sprintf(rep_prog,"%s",rep_base);

/* calcul de la date courante */
nseconds=time(NULL);
ptr=ctime(&nseconds);
i=0;
while( ptr[i] != '\n' )
        date_depouil[i++]=ptr[i];
date_depouil[i]=0;

tmptr = localtime(&nseconds);
sprintf(logname,"depouil%4.4d%2.2d%2.2d_%2.2d%2.2d.log",
	tmptr->tm_year+1900,1+tmptr->tm_mon,tmptr->tm_mday,
	tmptr->tm_hour,tmptr->tm_min);

//sprintf(commande,"%s/%s",rep_prog,logname);
/*sprintf(commande,"%s/automat/ddu_auto.log",rep_prog);
if(saisie.batch == VRAI)
	fp_log=fopen(commande,"w");
else 
	fp_log=fopen("/dev/stdout","w");*/
	fp_log=stdout;

fprintf(fp_log,"\n*** Depouillement des donnees DUMONT D'URVILLE");
fprintf(fp_log,"\n    Date de reception: %s\n",saisie.date_fich_compress);
fprintf(fp_log,"\n    Date de depouillement: %s\n",date_depouil);
fprintf(fp_log,"\n    Version: %f",VERSION);
fprintf(fp_log,"\n    date Version: %u",DATE_VERSION);
if(saisie.batch == VRAI)
	fprintf(fp_log,"\n    Mode: batch\n");
else	
	fprintf(fp_log,"\n    Mode: normal\n");

if(saisie.date_fich_compress[0] != 0)
	strcpy(date_trans,saisie.date_fich_compress);
else if(saisie.batch == VRAI)
	/* determination auto de la date de transfert */
	{
	sprintf(date_trans,"%4.4d/%2.2d/%2.2d",
		tmptr->tm_year+1900,1+tmptr->tm_mon,tmptr->tm_mday);
	}
else
	{
	printf("\nDate du transfert (aaaa/mm/jj) : ");
	scanf("%s",date_trans);
	};

strcpy(ligne,date_trans);
strcpy(an_trans,strtok(ligne,"/"));
strcpy(mois_trans,strtok(NULL,"/"));
strcpy(jour_trans,strtok(NULL,"/"));


year = atoi(an_trans);
if(year > 0 && year < 200)
	year+=1900;
fprintf(fp_log,"\n");

sprintf(date_trans,"%s%s%s",an_trans,mois_trans,jour_trans);


/* traitement du fichier .lzh */
/* -------------------------- */
strcpy(num_trans,"000");
if(saisie.decompress == VRAI)

	trait_fich_compress(&saisie,num_trans,fp_log);


/* init du fichier rapport de depouillement listaammjj.xxx */
/* ----------------------------------------------------- */
debut = NULL;
fin = NULL;

ret_ftw=ftw(rep_data,(*recup_fich),1);
	/* on stocke les noms de fichiers a traiter dans une liste chainee */
if(ret_ftw != 0)
	fprintf(fp_log,"\n*** ERREUR arborescence\n");


sprintf(nom_trans,"list%s%s%s.%s",an_trans,mois_trans,jour_trans,num_trans);
fp_trans = fopen(nom_trans,"w");
fprintf(fp_trans,"      Contenu du fichier Dumont d'Urville:\n");
fprintf(fp_trans,"      %s du %s %s %s\n",
	saisie.fich_trans,jour_trans,mois_trans,an_trans);
fprintf(fp_trans,"      Creation: %s\n",date_depouil);
fprintf(fp_trans,"\n                     ----------------------------------------\n\n");
		           

/* traitement des fichiers pour les italiens */
/* ----------------------------------------- */
sprintf(commande,"%s/italiens %s",rep_prog,strrstr(saisie.fich_trans,"/")+1);
if(saisie.decompress == VRAI)
	system(commande);


/* recuperation des differents types de donnees a traiter */
/* ------------------------------------------------------ */
sprintf(commande,"%s/type_fich.dat",rep_prog);
fp_type=fopen(commande,"r");
if(fp_type == NULL)
	{
	fprintf(fp_log,"*** Erreur ouverture fichier %s\n",commande);
	exit(255);
	};

debut_type = NULL;
fin_type = NULL;

while(fscanf(fp_type,"%s%s",type,manip) != EOF)
	{
	if(debut_type == 0)
		{
		/* on cree la structure */
		debut_type = malloc(sizeof(struct st_type) );
		debut_type->suivant = debut_type;
		debut_type->precedant=debut_type;
		fin_type=debut_type;
		fin_type->suivant=NULL;

		/* on y copie les infos */
                strcpy(debut_type->type,type);
	        strcpy(debut_type->manip,manip);
		}

	else
		{
		fin_type->suivant=malloc(sizeof(struct st_type) );
		fin_type->suivant->precedant=fin_type;
		fin_type = fin_type->suivant;
		fin_type->suivant=NULL;

		/* on y copie les infos */
        strcpy(fin_type->type,type);
	    strcpy(fin_type->manip,manip);

		};
	};
fclose(fp_type);

/* recuperation des types de fichiers lidar ou une inversion */
/* des numero de laser doit etre effectuee */
/* --------------------------------------------------------- */

sprintf(commande,"%s/inv_num_laser.dat",rep_prog);
fp_type=fopen(commande,"r");
if(fp_type == NULL)
	fprintf(fp_log,"Warning: erreur ouverture %s\n",commande);

debut_inv = NULL;
fin_inv = NULL;
while(fp_type !=NULL && fscanf(fp_type,"%s",type) != EOF)
	{
	if(debut_inv == 0)
		{
		/* on cree la structure */
		debut_inv = malloc(sizeof(struct st_type) );
		debut_inv->suivant=debut_inv;
		debut_inv->precedant=debut_inv;
		fin_inv=debut_inv;
		fin_inv->suivant=NULL;
		/* on y copie les infos */
        strcpy(debut_inv->type,type);
		}

	else
		{
		fin_inv->suivant=malloc(sizeof(struct st_type) );
		fin_inv->suivant->precedant=fin_inv;
		fin_inv = fin_inv->suivant;
		fin_inv->suivant=NULL;

		/* on y copie les infos */
        strcpy(fin_inv->type,type);
		};
	};
fclose(fp_type);

/* reperage des fichiers de calibration des sondes ozone */
/* ----------------------------------------------------- */
fprintf(fp_log,"recherche des fichier calibration  des sondes ozone\n");

fiche = debut;
debut_cal = NULL;
fin_cal = NULL;
while(fiche != NULL)
	{
	/* on recupere le nom du fichier sans l'arborescence */
    	buf=fiche->nomfich;
	while((buf2=(strstr(buf,"/")))!=NULL)
		{
		buf=buf2;
		buf++;
		};


	/* on regarde si c'est un fichier calibration ecc */
	/* en comparant le nom du fichier avec les types fichier_cal_ecc */
	trouve = FAUX;
	fiche_type = debut_type;
	while (fiche_type != NULL && trouve == FAUX)
		/* on balaye les types de fichiers jusqu'a trouver un calecc */
		{
         	if(strcmp(fiche_type->manip,"calecc")==0 &&
			compare(buf,fiche_type->type) == 1)
			/* si le nom du fichier correspond au type */
			/* de fichier trouve, on stocke le nom du fichier */
			{
			trouve = VRAI;
            		strcpy(fiche->manip,fiche_type->manip);

			if(debut_cal == 0)
				{
				/* on cree la structure */
				debut_cal = malloc(sizeof(struct calibre) );
				debut_cal->suivant=debut_cal;
				debut_cal->precedant=debut_cal;
				fin_cal=debut_cal;
				fin_cal->suivant=NULL;
				/* on y copie les infos */
				debut_cal->fiche=fiche;
				}

			else
				{
				fin_cal->suivant=malloc(sizeof(struct calibre) );
				fin_cal->suivant->precedant=fin_cal;
				fin_cal = fin_cal->suivant;
				fin_cal->suivant=NULL;

				/* on y copie les infos */
        			fin_cal->fiche=fiche;
				};
			}
		else
			fiche_type = fiche_type->suivant;

		};
		

	fiche=fiche->suivant;
	};

/* traitement des donnees DDU */
/* -------------------------- */

fiche = debut;
while(fiche != NULL)
	/* on passe tous les fichiers a traiter en revue */
	{
	/* on recupere le nom du fichier sans l'arborescence */
	fprintf(fp_log,"\nfichier traite: %s\n",fiche->nomfich);
    	buf=fiche->nomfich;
	while((buf2=(strstr(buf,"/")))!=NULL)
		{
		buf=buf2;
		buf++;
		};

	/* on passe le nom en minuscules */
	strcpy(nomfich,buf);
	i=0;
    	while(nomfich[i] != 0)
                {
                nomfich[i]=(char)tolower((int)nomfich[i]);
                i++;
                };

	/* on recherche le type du fichier et la manip associee */
	trouve = FAUX;
	fiche_type = debut_type;
	while (fiche_type != NULL && trouve == FAUX)
		{
         	if(compare(nomfich,fiche_type->type) == 1)
			{
			/* on lance le traitement approprie au type du fichier */
			
			trouve = VRAI;
            		strcpy(fiche->manip,fiche_type->manip);

			fprintf(fp_log,"type: %s manip: %s\n",fiche_type->type,fiche_type->manip);

			/* on effectue le traitement en fonction de la manip */
			if(strcmp(fiche_type->manip,"lidar")==0)
				/* traitement des bm, bs, bx dl dt dh dx dm ... */
				trait_lidar(buf,fp_log);

			else if(strcmp(fiche_type->manip,"ptu")==0)
				/* traitement des radiosondages meteo PTU */
				trait_sond_meteo(buf,fp_log);

			else if(strcmp(fiche_type->manip,"ecc")==0)
				/* traitement sondes ozones + calibration */
				trait_sond_ozone(&saisie,buf,fp_log);

			else if(strcmp(fiche_type->manip,"craero")==0)
				/* traitement compte-rendus Aerologique sonde ozone*/
				trait_cr_aero(buf,fp_log);

 			else if(strcmp(fiche_type->manip,"txtecc")==0)
				/* commentaire lach sonde ozone */
				trait_sond_ozone_com(&saisie,buf,fp_log);

			else if(strcmp(fiche_type->manip,"saoz")==0)
				/* traitement saoz */
				trait_saoz(&saisie,year,fp_log);

			else if(strcmp(fiche_type->manip,"temp")==0)
				/* traitement des fichiers lidar temperature */
				trait_lidar_temp(buf,fp_log);


			else if(strcmp(fiche_type->manip,"ohp")==0)
				/* traitement des fichiers ohp */
				trait_ohp(buf,date_trans,fp_log);

			else if(strcmp(fiche_type->manip,"bonjour")==0)
				/* traitement du fichier bonjour */
				trait_bonjour(&saisie,an_trans,mois_trans,jour_trans,num_trans,date_trans,fp_log);
 			};

        	fiche_type=fiche_type->suivant;
		};

	fiche=fiche->suivant;
	};


/* ecriture + impression fichier rapport de depouillement listaammjj.xxx */
/* ------------------------------------------------------------------- */
fp_insert=fopen("insert.dat","w");
	/* fichier contenant les fichiers a inserer dans la base */
fp_ohp=fopen("ohp.dat","w");
	/* fichier contenant les fichiers a envoyer a l'ohp */
fp_attente=fopen("attente.dat","w");
	/* fichier contenant les fichiers en attente de traitment */

fprintf(fp_insert,"%s %s\n",nom_trans,date_trans);
	/* on insere le nom du fichier list dans le fichier des donnees */
	/* a inserer dans la base */

fiche = debut;
while(fiche != NULL)
	{

	/* ecriture des nom des fichiers dumont et de leur nouveau nom */
	/* eventuel dans le fichier list */
	if(strcmp(saisie.fich_trans,fiche->nomfich) != 0)
		fprintf(fp_trans," %s -> %s\n",strrstr(fiche->nomfich,"/")+1,fiche->newnom);
		/* on ecrit pas le nom du fichier compresse dans le fichier list */

	/* cas particulier des fichiers a destination de l'OHP */
	/* ils ne sont pas traites mais sont stockes dans un rep a part */
	if(strcmp(fiche->manip,"ohp")==0)
		fprintf(fp_ohp,"%s\n",fiche->newnom);

	/* si un fichier dumont n'a pas de nouveau nom, c'est qu'il n'a */
	/* pas encore de traitement prevu et on le met en attente */
	else if( fiche->newnom[0] != 0 )
		fprintf(fp_insert,"%s %s\n",fiche->newnom,fiche->date);
	else
		fprintf(fp_attente,"%s\n",fiche->nomfich);
			
	fiche = fiche->suivant;
	/* on passe a la fich suivante */

	};
fclose(fp_trans);
fclose(fp_insert);
fclose(fp_attente);
fclose(fp_ohp);


if(saisie.mail == VRAI)
	{
	fprintf(fp_log,"envoi par mail de %s aux admins\n",nom_trans);
	strcpy(nomfich,nom_trans);
	sprintf(sujet,"Liste fichiers DDU du %s/%s/%s",an_trans,mois_trans,jour_trans);
	sprintf(destinataires,"%s/mail_admin.dat",rep_prog);
	envoi_mail(nomfich,sujet,destinataires,fp_log);
	};

fclose(fp_log);

}
